Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkPointLocator Class Reference

`#include <vtkPointLocator.h>`

Inheritance diagram for vtkPointLocator:

[legend]
Collaboration diagram for vtkPointLocator:

[legend]
List of all members.

## Detailed Description

quickly locate points in 3-space

Date:
  2002/12/26 18:24:21

Revision:
  1.52

vtkPointLocator is a spatial search object to quickly locate points in 3D. vtkPointLocator works by dividing a specified region of space into a regular array of "rectangular" buckets, and then keeping a list of points that lie in each bucket. Typical operation involves giving a position in 3D and finding the closest point.

vtkPointLocator has two distinct methods of interaction. In the first method, you supply it with a dataset, and it operates on the points in the dataset. In the second method, you supply it with an array of points, and the object operates on the array.

Warning:
  Many other types of spatial locators have been developed such as octrees and kd-trees. These are often more efficient for the operations described here.

See also:
  vtkCellPicker vtkPointPicker

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (39%)
  - Martin, Ken (18%)
  - Blue, Rusty (11%)
  - Lorensen, Bill (9%)
  - Miller, Jim (7%)
  - Geveci, Berk (6%)

CVS logs (CVSweb):
  - .`h` (`/Common/vtkPointLocator.h)`
  - .`cxx` (`/Common/vtkPointLocator.cxx)`

Tests:
  vtkPointLocator (Tests)

Definition at line 70 of file vtkPointLocator.h.

## Public Types
typedef vtkLocator | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
virtual int | InitPointInsertion (vtkPoints *newPts, const float bounds[6])
virtual void | InsertPoint (vtkIdType ptId, const float x[3])
virtual vtkIdType | InsertNextPoint (const float x[3])
virtual int | InsertUniquePoint (const float x[3], vtkIdType &ptId)
virtual vtkIdType | FindClosestInsertedPoint (const float x[3])
virtual vtkIdList * | GetPointsInBucket (const float x[3], int ijk[3])
virtual void | SetDivisions (int, int, int)
virtual void | SetDivisions (int[3])
virtual int * | GetDivisions ()
virtual void | GetDivisions (int data[3])
virtual void | SetNumberOfPointsPerBucket (int)
virtual int | GetNumberOfPointsPerBucket ()
virtual vtkIdType | FindClosestPoint (const float x[3])
vtkIdType | FindClosestPoint (float x, float y, float z)
vtkIdType | FindClosestPointWithinRadius (float radius, const float x[3], float &dist2)
vtkIdType | FindClosestPointWithinRadius (float radius, const float x[3], float inputDataLength, float &dist2)
virtual int | InitPointInsertion (vtkPoints *newPts, const float bounds[6], vtkIdType estSize)
vtkIdType | IsInsertedPoint (float x, float y, float z)
virtual vtkIdType | IsInsertedPoint (const float x[3])
virtual void | FindClosestNPoints (int N, const float x[3], vtkIdList *result)
virtual void | FindClosestNPoints (int N, float x, float y, float z, vtkIdList *result)
virtual void | FindDistributedPoints (int N, const float x[3], vtkIdList *result, int M)
virtual void | FindDistributedPoints (int N, float x, float y, float z, vtkIdList *result, int M)
virtual void | FindPointsWithinRadius (float R, const float x[3], vtkIdList *result)
virtual void | FindPointsWithinRadius (float R, float x, float y, float z, vtkIdList *result)
void | Initialize ()
void | FreeSearchStructure ()
void | BuildLocator ()
void | GenerateRepresentation (int level, vtkPolyData *pd)
## Static Public Methods
vtkPointLocator * | New ()
int | IsTypeOf (const char *type)
vtkPointLocator * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkPointLocator ()
| ~vtkPointLocator ()
void | GetBucketNeighbors (vtkNeighborPoints *buckets, const int ijk[3], const int ndivs[3], int level)
void | GetOverlappingBuckets (vtkNeighborPoints *buckets, const float x[3], const int ijk[3], float dist, int level)
void | GetOverlappingBuckets (vtkNeighborPoints *buckets, const float x[3], float dist, int prevMinLevel[3], int prevMaxLevel[3])
void | GenerateFace (int face, int i, int j, int k, vtkPoints *pts, vtkCellArray *polys)
float | Distance2ToBucket (const float x[3], const int nei[3])
float | Distance2ToBounds (const float x[3], const float bounds[6])
## Protected Attributes
vtkPoints * | Points
int | Divisions [3]
int | NumberOfPointsPerBucket
float | Bounds [6]
vtkIdList ** | HashTable
vtkIdType | NumberOfBuckets
float | H [3]
float | InsertionTol2
vtkIdType | InsertionPointId
float | InsertionLevel

## Member Typedef Documentation

typedef vtkLocator vtkPointLocator::Superclass

| Reimplemented from vtkLocator. Reimplemented in vtkMergePoints. Definition at line 77 of file vtkPointLocator.h.

## Constructor & Destructor Documentation

vtkPointLocator::vtkPointLocator | ( |  | ) | `[protected]`

vtkPointLocator::~vtkPointLocator | ( |  | ) | `[protected]`

## Member Function Documentation

vtkPointLocator* vtkPointLocator::New | ( |  | ) | `[static]`

| Construct with automatic computation of divisions, averaging 25 points per bucket. Reimplemented from vtkObject. Reimplemented in vtkMergePoints.

virtual const char* vtkPointLocator::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkLocator. Reimplemented in vtkMergePoints.

int vtkPointLocator::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkLocator. Reimplemented in vtkMergePoints.

virtual int vtkPointLocator::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkLocator. Reimplemented in vtkMergePoints.

vtkPointLocator* vtkPointLocator::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkLocator. Reimplemented in vtkMergePoints.

void vtkPointLocator::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkLocator. Reimplemented in vtkMergePoints.

virtual void vtkPointLocator::SetDivisions | ( | int | ,
|  | int | ,
|  | int |
| ) | `[virtual]`

| Set the number of divisions in x-y-z directions.

virtual void vtkPointLocator::SetDivisions | ( | int | [3] | ) | `[virtual]`

| Set the number of divisions in x-y-z directions.

virtual int* vtkPointLocator::GetDivisions | ( |  | ) | `[virtual]`

| Set the number of divisions in x-y-z directions.

virtual void vtkPointLocator::GetDivisions | ( | int | data[3] | ) | `[virtual]`

| Set the number of divisions in x-y-z directions.

virtual void vtkPointLocator::SetNumberOfPointsPerBucket | ( | int |  | ) | `[virtual]`

| Specify the average number of points in each bucket.

virtual int vtkPointLocator::GetNumberOfPointsPerBucket | ( |  | ) | `[virtual]`

| Specify the average number of points in each bucket.

virtual vtkIdType vtkPointLocator::FindClosestPoint | ( | const float | x[3] | ) | `[virtual]`

| Given a position x, return the id of the point closest to it. Alternative method requires separate x-y-z values. These methods are thread safe if BuildLocator() is directly or indirectly called from a single thread first.

vtkIdType vtkPointLocator::FindClosestPoint | ( | float | x,
|  | float | y,
|  | float | z
| ) |

| Given a position x, return the id of the point closest to it. Alternative method requires separate x-y-z values. These methods are thread safe if BuildLocator() is directly or indirectly called from a single thread first.

vtkIdType vtkPointLocator::FindClosestPointWithinRadius | ( | float | radius,
|  | const float | x[3],
|  | float & | dist2
| ) |

| Given a position x and a radius r, return the id of the point closest to the point in that radius. These methods are thread safe if BuildLocator() is directly or indirectly called from a single thread first. dist2 returns the squared distance to the point.

vtkIdType vtkPointLocator::FindClosestPointWithinRadius | ( | float | radius,
|  | const float | x[3],
|  | float | inputDataLength,
|  | float & | dist2
| ) |

| Given a position x and a radius r, return the id of the point closest to the point in that radius. These methods are thread safe if BuildLocator() is directly or indirectly called from a single thread first. dist2 returns the squared distance to the point.

virtual int vtkPointLocator::InitPointInsertion | ( | vtkPoints * | newPts,
|  | const float | bounds[6]
| ) | `[virtual]`

| Initialize the point insertion process. The newPts is an object representing point coordinates into which incremental insertion methods place their data. Bounds are the box that the points lie in. Not thread safe.

virtual int vtkPointLocator::InitPointInsertion | ( | vtkPoints * | newPts,
|  | const float | bounds[6],
|  | vtkIdType | estSize
| ) | `[virtual]`

| Initialize the point insertion process. The newPts is an object representing point coordinates into which incremental insertion methods place their data. Bounds are the box that the points lie in. Not thread safe.

virtual void vtkPointLocator::InsertPoint | ( | vtkIdType | ptId,
|  | const float | x[3]
| ) | `[virtual]`

| Incrementally insert a point into search structure with a particular index value. You should use the method IsInsertedPoint() to see whether this point has already been inserted (that is, if you desire to prevent duplicate points). Before using this method you must make sure that newPts have been supplied, the bounds has been set properly, and that divs are properly set. (See InitPointInsertion().) Not thread safe.

virtual vtkIdType vtkPointLocator::InsertNextPoint | ( | const float | x[3] | ) | `[virtual]`

| Incrementally insert a point into search structure. The method returns the insertion location (i.e., point id). You should use the method IsInsertedPoint() to see whether this point has already been inserted (that is, if you desire to prevent duplicate points). Before using this method you must make sure that newPts have been supplied, the bounds has been set properly, and that divs are properly set. (See InitPointInsertion().) Not thread safe.

vtkIdType vtkPointLocator::IsInsertedPoint | ( | float | x,
|  | float | y,
|  | float | z
| ) | `[inline]`

| Determine whether point given by x[3] has been inserted into points list. Return id of previously inserted point if this is true, otherwise return -1. This method is thread safe. Reimplemented in vtkMergePoints. Definition at line 149 of file vtkPointLocator.h. References vtkIdType. Referenced by vtkMergePoints::IsInsertedPoint().

virtual vtkIdType vtkPointLocator::IsInsertedPoint | ( | const float | x[3] | ) | `[virtual]`

| Determine whether point given by x[3] has been inserted into points list. Return id of previously inserted point if this is true, otherwise return -1. This method is thread safe. Reimplemented in vtkMergePoints.

virtual int vtkPointLocator::InsertUniquePoint | ( | const float | x[3],
|  | vtkIdType & | ptId
| ) | `[virtual]`

| Determine whether point given by x[3] has been inserted into points list. Return 0 if point was already in the list, otherwise return 1. If the point was not in the list, it will be ADDED. In either case, the id of the point (newly inserted or not) is returned in the ptId argument. Note this combines the functionality of IsInsertedPoint() followed by a call to InsertNextPoint(). This method is not thread safe. Reimplemented in vtkMergePoints. Referenced by vtkNonLinearCell::InsertPoint().

virtual vtkIdType vtkPointLocator::FindClosestInsertedPoint | ( | const float | x[3] | ) | `[virtual]`

| Given a position x, return the id of the point closest to it. This method is used when performing incremental point insertion. Note that -1 indicates that no point was found. This method is thread safe if BuildLocator() is directly or indirectly called from a single thread first.

virtual void vtkPointLocator::FindClosestNPoints | ( | int | N,
|  | const float | x[3],
|  | vtkIdList * | result
| ) | `[virtual]`

| Find the closest N points to a position. This returns the closest N points to a position. A faster method could be created that returned N close points to a position, but necessarily the exact N closest. The returned points are sorted from closest to farthest. These methods are thread safe if BuildLocator() is directly or indirectly called from a single thread first.

virtual void vtkPointLocator::FindClosestNPoints | ( | int | N,
|  | float | x,
|  | float | y,
|  | float | z,
|  | vtkIdList * | result
| ) | `[virtual]`

| Find the closest N points to a position. This returns the closest N points to a position. A faster method could be created that returned N close points to a position, but necessarily the exact N closest. The returned points are sorted from closest to farthest. These methods are thread safe if BuildLocator() is directly or indirectly called from a single thread first.

virtual void vtkPointLocator::FindDistributedPoints | ( | int | N,
|  | const float | x[3],
|  | vtkIdList * | result,
|  | int | M
| ) | `[virtual]`

| Find the closest points to a position such that each octant of space around the position contains at least N points. Loosely limit the search to a maximum number of points evaluated, M. These methods are thread safe if BuildLocator() is directly or indirectly called from a single thread first.

virtual void vtkPointLocator::FindDistributedPoints | ( | int | N,
|  | float | x,
|  | float | y,
|  | float | z,
|  | vtkIdList * | result,
|  | int | M
| ) | `[virtual]`

| Find the closest points to a position such that each octant of space around the position contains at least N points. Loosely limit the search to a maximum number of points evaluated, M. These methods are thread safe if BuildLocator() is directly or indirectly called from a single thread first.

virtual void vtkPointLocator::FindPointsWithinRadius | ( | float | R,
|  | const float | x[3],
|  | vtkIdList * | result
| ) | `[virtual]`

| Find all points within a specified radius R of position x. The result is not sorted in any specific manner. These methods are thread safe if BuildLocator() is directly or indirectly called from a single thread first.

virtual void vtkPointLocator::FindPointsWithinRadius | ( | float | R,
|  | float | x,
|  | float | y,
|  | float | z,
|  | vtkIdList * | result
| ) | `[virtual]`

| Find all points within a specified radius R of position x. The result is not sorted in any specific manner. These methods are thread safe if BuildLocator() is directly or indirectly called from a single thread first.

virtual vtkIdList* vtkPointLocator::GetPointsInBucket | ( | const float | x[3],
|  | int | ijk[3]
| ) | `[virtual]`

| Given a position x, return the list of points in the bucket that contains the point. It is possible that NULL is returned. The user provides an ijk array that is the indices into the locator. This method is thread safe.

void vtkPointLocator::Initialize | ( |  | ) | `[virtual]`

| See vtkLocator interface documentation. These methods are not thread safe. Reimplemented from vtkLocator.

void vtkPointLocator::FreeSearchStructure | ( |  | ) | `[virtual]`

| See vtkLocator interface documentation. These methods are not thread safe. Implements vtkLocator.

void vtkPointLocator::BuildLocator | ( |  | ) | `[virtual]`

| See vtkLocator interface documentation. These methods are not thread safe. Implements vtkLocator.

void vtkPointLocator::GenerateRepresentation | ( | int | level,
|  | vtkPolyData * | pd
| ) | `[virtual]`

| See vtkLocator interface documentation. These methods are not thread safe. Implements vtkLocator.

void vtkPointLocator::GetBucketNeighbors | ( | vtkNeighborPoints * | buckets,
|  | const int | ijk[3],
|  | const int | ndivs[3],
|  | int | level
| ) | `[protected]`

void vtkPointLocator::GetOverlappingBuckets | ( | vtkNeighborPoints * | buckets,
|  | const float | x[3],
|  | const int | ijk[3],
|  | float | dist,
|  | int | level
| ) | `[protected]`

void vtkPointLocator::GetOverlappingBuckets | ( | vtkNeighborPoints * | buckets,
|  | const float | x[3],
|  | float | dist,
|  | int | prevMinLevel[3],
|  | int | prevMaxLevel[3]
| ) | `[protected]`

void vtkPointLocator::GenerateFace | ( | int | face,
|  | int | i,
|  | int | j,
|  | int | k,
|  | vtkPoints * | pts,
|  | vtkCellArray * | polys
| ) | `[protected]`

float vtkPointLocator::Distance2ToBucket | ( | const float | x[3],
|  | const int | nei[3]
| ) | `[protected]`

float vtkPointLocator::Distance2ToBounds | ( | const float | x[3],
|  | const float | bounds[6]
| ) | `[protected]`

## Member Data Documentation

vtkPoints* vtkPointLocator::Points`[protected]`

| Definition at line 243 of file vtkPointLocator.h.

int vtkPointLocator::Divisions[3]`[protected]`

| Definition at line 244 of file vtkPointLocator.h.

int vtkPointLocator::NumberOfPointsPerBucket`[protected]`

| Definition at line 245 of file vtkPointLocator.h.

float vtkPointLocator::Bounds[6]`[protected]`

| Definition at line 246 of file vtkPointLocator.h.

vtkIdList** vtkPointLocator::HashTable`[protected]`

| Definition at line 247 of file vtkPointLocator.h.

vtkIdType vtkPointLocator::NumberOfBuckets`[protected]`

| Definition at line 248 of file vtkPointLocator.h.

float vtkPointLocator::H[3]`[protected]`

| Definition at line 249 of file vtkPointLocator.h.

float vtkPointLocator::InsertionTol2`[protected]`

| Definition at line 251 of file vtkPointLocator.h.

vtkIdType vtkPointLocator::InsertionPointId`[protected]`

| Definition at line 252 of file vtkPointLocator.h.

float vtkPointLocator::InsertionLevel`[protected]`

| Definition at line 254 of file vtkPointLocator.h.

The documentation for this class was generated from the following file:

- Common/vtkPointLocator.h